<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::integration::ObservableMessageRequest Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1integration.html">integration</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html">ObservableMessageRequest</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::integration::ObservableMessageRequest Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_observable_message_request_8h_source.html">ObservableMessageRequest.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::integration::ObservableMessageRequest:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1integration_1_1_observable_message_request_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1integration_1_1_observable_message_request_inherit__map" id="alexa_client_s_d_k_1_1integration_1_1_observable_message_request_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html" title="alexaClientSDK::avsCommon\l::avs::MessageRequest" alt="" coords="7,5,204,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::integration::ObservableMessageRequest:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1integration_1_1_observable_message_request_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1integration_1_1_observable_message_request_coll__map" id="alexa_client_s_d_k_1_1integration_1_1_observable_message_request_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html" title="alexaClientSDK::avsCommon\l::avs::MessageRequest" alt="" coords="7,5,204,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a353893c57bcc6351031e4960b6d3feb1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#a353893c57bcc6351031e4960b6d3feb1">ObservableMessageRequest</a> (const std::string &amp;jsonContent, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">avsCommon::avs::attachment::AttachmentReader</a> &gt; attachmentReader=nullptr)</td></tr>
<tr class="separator:a353893c57bcc6351031e4960b6d3feb1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac5887c4dea8cdc4de3ba71010e12d41"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#aac5887c4dea8cdc4de3ba71010e12d41">sendCompleted</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> status) override</td></tr>
<tr class="separator:aac5887c4dea8cdc4de3ba71010e12d41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71d3cce299cdbf95b8c34464c6e53e11"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#a71d3cce299cdbf95b8c34464c6e53e11">exceptionReceived</a> (const std::string &amp;exceptionMessage) override</td></tr>
<tr class="separator:a71d3cce299cdbf95b8c34464c6e53e11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bca122326487ecfe2d49c81b7bf429f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#a0bca122326487ecfe2d49c81b7bf429f">getSendMessageStatus</a> () const</td></tr>
<tr class="separator:a0bca122326487ecfe2d49c81b7bf429f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae1d6b169d5df0239204eab2ead7bede"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#aae1d6b169d5df0239204eab2ead7bede">waitFor</a> (const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a>, const std::chrono::seconds=std::chrono::seconds(10))</td></tr>
<tr class="separator:aae1d6b169d5df0239204eab2ead7bede"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc2a1e52b517c7be181c23b196b54f30"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#abc2a1e52b517c7be181c23b196b54f30">hasSendCompleted</a> ()</td></tr>
<tr class="memdesc:abc2a1e52b517c7be181c23b196b54f30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function indicating if sendCompleted has been called.  <a href="#abc2a1e52b517c7be181c23b196b54f30">More...</a><br /></td></tr>
<tr class="separator:abc2a1e52b517c7be181c23b196b54f30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afcba5c537e217f95a0d7a2dbfaf96147"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#afcba5c537e217f95a0d7a2dbfaf96147">wasExceptionReceived</a> ()</td></tr>
<tr class="memdesc:afcba5c537e217f95a0d7a2dbfaf96147"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function indicating if exceptionReceived has been called.  <a href="#afcba5c537e217f95a0d7a2dbfaf96147">More...</a><br /></td></tr>
<tr class="separator:afcba5c537e217f95a0d7a2dbfaf96147"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">alexaClientSDK::avsCommon::avs::MessageRequest</a></td></tr>
<tr class="memitem:a74d6eb572d6c3f1172cfa5108fcd5a64 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a74d6eb572d6c3f1172cfa5108fcd5a64">MessageRequest</a> (const std::string &amp;jsonContent, const std::string &amp;uriPathExtension=&quot;&quot;)</td></tr>
<tr class="separator:a74d6eb572d6c3f1172cfa5108fcd5a64 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a62d7ec22c5c11079faec9f1a7a834a inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a8a62d7ec22c5c11079faec9f1a7a834a">~MessageRequest</a> ()</td></tr>
<tr class="separator:a8a62d7ec22c5c11079faec9f1a7a834a inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f6ff7cc1d2b684a16ea33e706b5600e inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a7f6ff7cc1d2b684a16ea33e706b5600e">addAttachmentReader</a> (const std::string &amp;name, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">attachment::AttachmentReader</a> &gt; attachmentReader)</td></tr>
<tr class="separator:a7f6ff7cc1d2b684a16ea33e706b5600e inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2e3df68ead7a256b7c617cc98abb9d6 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ae2e3df68ead7a256b7c617cc98abb9d6">getJsonContent</a> ()</td></tr>
<tr class="separator:ae2e3df68ead7a256b7c617cc98abb9d6 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0cb8cc3cdd1e5094eff0776ad54d518 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ab0cb8cc3cdd1e5094eff0776ad54d518">getUriPathExtension</a> ()</td></tr>
<tr class="separator:ab0cb8cc3cdd1e5094eff0776ad54d518 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeee198a7b81ca9606891bc78a559490a inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#aeee198a7b81ca9606891bc78a559490a">attachmentReadersCount</a> ()</td></tr>
<tr class="separator:aeee198a7b81ca9606891bc78a559490a inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6767e31d1960a086975471813345a86f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">NamedReader</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a6767e31d1960a086975471813345a86f">getAttachmentReader</a> (size_t index)</td></tr>
<tr class="separator:a6767e31d1960a086975471813345a86f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0a451c99ee5d47c639e89b668e7830f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ad0a451c99ee5d47c639e89b668e7830f">addObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt; observer)</td></tr>
<tr class="separator:ad0a451c99ee5d47c639e89b668e7830f inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a31fe3acc9b87911b14fb4a10d98d6dda inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a31fe3acc9b87911b14fb4a10d98d6dda">removeObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt; observer)</td></tr>
<tr class="separator:a31fe3acc9b87911b14fb4a10d98d6dda inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">alexaClientSDK::avsCommon::avs::MessageRequest</a></td></tr>
<tr class="memitem:a423d6a102e3d537ccb4b56d185a14bf8 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::mutex&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a423d6a102e3d537ccb4b56d185a14bf8">m_observerMutex</a></td></tr>
<tr class="memdesc:a423d6a102e3d537ccb4b56d185a14bf8 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mutex to guard access of m_observers.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a423d6a102e3d537ccb4b56d185a14bf8">More...</a><br /></td></tr>
<tr class="separator:a423d6a102e3d537ccb4b56d185a14bf8 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad67b78688c70a3a33e137ebb51f3bd39 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ad67b78688c70a3a33e137ebb51f3bd39">m_observers</a></td></tr>
<tr class="memdesc:ad67b78688c70a3a33e137ebb51f3bd39 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set of observers of MessageRequestObserverInterface.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ad67b78688c70a3a33e137ebb51f3bd39">More...</a><br /></td></tr>
<tr class="separator:ad67b78688c70a3a33e137ebb51f3bd39 inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7f042e8bce1352f1359b111e5c5355b inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#af7f042e8bce1352f1359b111e5c5355b">m_jsonContent</a></td></tr>
<tr class="memdesc:af7f042e8bce1352f1359b111e5c5355b inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="mdescLeft">&#160;</td><td class="mdescRight">The JSON content to be sent to AVS.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#af7f042e8bce1352f1359b111e5c5355b">More...</a><br /></td></tr>
<tr class="separator:af7f042e8bce1352f1359b111e5c5355b inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23cd79d5ac89983f17b6c1d90a8942bf inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a23cd79d5ac89983f17b6c1d90a8942bf">m_uriPathExtension</a></td></tr>
<tr class="memdesc:a23cd79d5ac89983f17b6c1d90a8942bf inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="mdescLeft">&#160;</td><td class="mdescRight">The path extension to be appended to the base URL when sending.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a23cd79d5ac89983f17b6c1d90a8942bf">More...</a><br /></td></tr>
<tr class="separator:a23cd79d5ac89983f17b6c1d90a8942bf inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a057aa763160b1417dc31f93706fa5a8f inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::shared_ptr&lt; <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">NamedReader</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a057aa763160b1417dc31f93706fa5a8f">m_readers</a></td></tr>
<tr class="memdesc:a057aa763160b1417dc31f93706fa5a8f inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="mdescLeft">&#160;</td><td class="mdescRight">The AttachmentReaders of the Attachments data to be sent to AVS.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a057aa763160b1417dc31f93706fa5a8f">More...</a><br /></td></tr>
<tr class="separator:a057aa763160b1417dc31f93706fa5a8f inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a353893c57bcc6351031e4960b6d3feb1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a353893c57bcc6351031e4960b6d3feb1">&#9670;&nbsp;</a></span>ObservableMessageRequest()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::integration::ObservableMessageRequest::ObservableMessageRequest </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>jsonContent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">avsCommon::avs::attachment::AttachmentReader</a> &gt;&#160;</td>
          <td class="paramname"><em>attachmentReader</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a71d3cce299cdbf95b8c34464c6e53e11"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71d3cce299cdbf95b8c34464c6e53e11">&#9670;&nbsp;</a></span>exceptionReceived()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::integration::ObservableMessageRequest::exceptionReceived </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>exceptionMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This function will be called if AVS responds with an exception message to this message request being sent.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionMessage</td><td>The exception message. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a54ed5e88d810b85fed9f07b54def8fd3">alexaClientSDK::avsCommon::avs::MessageRequest</a>.</p>

</div>
</div>
<a id="a0bca122326487ecfe2d49c81b7bf429f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0bca122326487ecfe2d49c81b7bf429f">&#9670;&nbsp;</a></span>getSendMessageStatus()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> alexaClientSDK::integration::ObservableMessageRequest::getSendMessageStatus </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Utility function to get the status once the message has been sent. </p>

</div>
</div>
<a id="abc2a1e52b517c7be181c23b196b54f30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc2a1e52b517c7be181c23b196b54f30">&#9670;&nbsp;</a></span>hasSendCompleted()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::integration::ObservableMessageRequest::hasSendCompleted </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function indicating if sendCompleted has been called. </p>

</div>
</div>
<a id="aac5887c4dea8cdc4de3ba71010e12d41"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aac5887c4dea8cdc4de3ba71010e12d41">&#9670;&nbsp;</a></span>sendCompleted()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::integration::ObservableMessageRequest::sendCompleted </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a>&#160;</td>
          <td class="paramname"><em>status</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This is called once the send request has completed. The status parameter indicates success or failure. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">status</td><td>Whether the send request succeeded or failed. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#aef0f5892c16d12f22d74011c92047be9">alexaClientSDK::avsCommon::avs::MessageRequest</a>.</p>

</div>
</div>
<a id="aae1d6b169d5df0239204eab2ead7bede"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aae1d6b169d5df0239204eab2ead7bede">&#9670;&nbsp;</a></span>waitFor()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::integration::ObservableMessageRequest::waitFor </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a>&#160;</td>
          <td class="paramname"><em>sendMessageStatus</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::chrono::seconds&#160;</td>
          <td class="paramname"><em>duration</em> = <code>std::chrono::seconds(10)</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Function to allow waiting for a particular status back from the component sending the message to AVS. </p>

</div>
</div>
<a id="afcba5c537e217f95a0d7a2dbfaf96147"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afcba5c537e217f95a0d7a2dbfaf96147">&#9670;&nbsp;</a></span>wasExceptionReceived()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::integration::ObservableMessageRequest::wasExceptionReceived </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function indicating if exceptionReceived has been called. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/Integration/include/Integration/<a class="el" href="_observable_message_request_8h_source.html">ObservableMessageRequest.h</a></li>
<li>/workplace/avs-device-sdk/Integration/src/<a class="el" href="_observable_message_request_8cpp.html">ObservableMessageRequest.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
